import asyncio
import random

async def task_c(q):
    # Wait for future objects in the queue and give them values
    while True:
        future = await q.get()
        if future is None: break
        # Wait for a random number of seconds between 1 and 5
        await asyncio.sleep(random.randint(1, 5))
        # Generate a random value and set it on the future
        value = random.randint(1, 100)
        future.set_result(value)


async def task_a(q):
    # Create a future object and put it in the queue
    future = asyncio.Future()
    await q.put(future)
    print(f"Request sent from task_a to task_c")
    # Wait for the future to be set with a value by task_c
    value = await future
    # Do something with the value
    print(f"Received value from task_c in task_a: {value}")

async def task_b(q):
    # Create a future object and put it in the queue
    future = asyncio.Future()
    await q.put(future)
    print(f"Request sent from task_b to task_c")
    # Wait for the future to be set with a value by task_c
    value = await future
    # Do something with the value
    print(f"Received value from task_c in task_b: {value}")
    # signalize task c to terminate by sending it None value
    await q.put(None)

async def main():
    # Create the queue
    q = asyncio.Queue()
    # Create tasks for task_a, task_b, and task_c
    tasks = [
        task_a(q),
        task_b(q),
        task_c(q)
    ]
    # Wait for all tasks to complete
    await asyncio.gather(*tasks)

# Run the main function
asyncio.run(main())
