from dependency_injector import containers, providers

class NameService:
    def get_name(self) -> str:
        return "Pera"

class Greeter:
    def __init__(self, name_service: NameService):
        self.name_service = name_service

    def greet(self) -> str:
        name = self.name_service.get_name()
        return f"Hello, {name}!"

class Container(containers.DeclarativeContainer):
    name_service = providers.Singleton(NameService)
    greeter = providers.Factory(Greeter, name_service)

container = Container()

greeter = container.greeter()
print(greeter.greet())
