<?php
require_once __DIR__.'/vendor/autoload.php';

use DI\Container;
use DI\ContainerBuilder;

class Greeter {
    private $nameService;

    public function __construct(NameService $nameService) {
        $this->nameService = $nameService;
    }
    
    public function greet() {
        $name = $this->nameService->getName();
        echo "Hello, $name!";
    }
}

class NameService {
    public function getName() {
        return "Laza";
    }
}

$containerBuilder = new ContainerBuilder();
$containerBuilder->addDefinitions([
    NameService::class => \DI\autowire(NameService::class),
    Greeter::class => \DI\autowire(Greeter::class)
]);
$container = $containerBuilder->build();

$greeter = $container->get(Greeter::class);
$greeter->greet();
